/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/
#ifndef CLIENT_H
#define CLIENT_H

#include "unlimited.h"

struct pref_ul {
	Bool		useobjf;	/* should object functions be used? */

	Bool 		world;		/* if don't have world map, download it? */

	sInt		updatefreq;	/* updates/second */
	TIMESTAMP_UL	updatefreqts;

	uInt		maxupdates;	/* maximum # of updates; when reached,
					send a PRECISECONTROL_UL */
	
	uByte		servername[50];
	sInt 		serverport;

#ifdef CLIENT
	ENGPREF_UL 	engprefs;	/* engine preferences */
	sInt 		maxsoundcars;	/* max number of cars hearable */
	sInt 		maxfrontviewcars;/* max number of cars visible at front */
	sInt 		maxrearviewcars;/* max number of cars visible at rear */

	CONTROL_UL	controller;
	KEYBSET_UL	keybset;
	
	/* window stuff */
	sInt		width, height, depth;
	Bool		usedb, single;
	
	/* sound */
	Bool		sound;		/* use sound? */
	sInt		frequency;
	uByte		sounddevice[50];
	
	/* messages */
	sInt		maxmessages;
	uLong		messagetime;	/* in our timestamp format */
#endif
};
typedef struct pref_ul PREF_UL;

#ifdef CLIENT
/* font.c */
extern void setmessagetime	( uLong time );
extern void addmessage		( uByte *m, uShort from );
extern void cleanmessages	( void );
extern void initFont 		( void );
extern void showmessages	( void );
#endif

/* pref.c */
extern PREF_UL 	*prefs;
extern sInt loadprefs		( void );
extern void saveprefs		( void );

/* resp.c */
extern sInt doresp		( SERVERM_UL *resp );
extern void sendSpecialMessage	( CLIENTM_UL *request );

/* ulclient.c */
extern dFloat			frametime;
extern CLIENT_UL 		*own;
extern Bool			paused;
extern SIMPLECLIENT_UL 		*firstcli;
#ifdef CLIENT
extern FILE			*sound;
#endif

#endif
