/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */

#ifndef U_EVENTS_H
#define U_EVENTS_H

enum u_eventtype {
	U_EVENT_KEY, U_EVENT_MOUSE, U_EVENT_JOYSTICK, U_EVENT_COLLISION, 
	/* keep U_EVENT_EXTRA last */
	U_EVENT_EXTRA
};
typedef enum u_eventtype u_eventType;

/*
 * Keyboard 
 */


/* 
 * Mouse
 */

enum u_eventmousetype {
	U_BUTTON_PRESSED, U_BUTTON_RELEASED, U_BUTTON_CLICKED, U_MOUSE_MOVED
};
typedef enum u_eventmousetype u_eventMouseType;

#define U_MOUSE_LEFT_BUTTON		1
#define U_MOUSE_MIDDLE_BUTTON		2
#define U_MOUSE_RIGHT_BUTTON		4

union u_event {
	u_eventType			type;

	struct u_event_key {
		sInt 			key;
	} key;
	
	struct u_event_mouse {
		u_eventMouseType	action;
		u_mouseButton		button;
		sInt			mousex, mousey;
	} mouse;
	
	struct u_event_joystick {
		sInt			joyx, joyy;
		sInt			button;
	} joystick;

	struct u_event_collision {
		u_Vector		point;
	} collision;

	struct u_event_extra {
		void			*extra;
	} extra;
};
typedef union u_event u_Event;

#endif
