/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */

u_gType u_gType_None[] = "\0";

u_Geometry *u_createGeometry ( uByte *name ) {
	u_Geometry		*geo;

	if ( !(geo = (u_Geometry *)malloc(sizeof(u_Geometry))) )
		return NULL;

	zeroV( &geo->position );
	zeroV( &geo->direction );
	geo->angle = 0;

	if ( name != NULL ) {
		geo->name = strdup(name);
		if ( u_loadGeometry( name, geo ) == ERROR )
			fprintf( stderr, "Couldn't load file" );
	}
	else {
		geo->name = NULL;
		geo->gtype = u_gType_None;
	}

/***** do bouding sphere */

	return geo;
}

void u_freeGeometry ( u_Geometry *geo ) {
	if ( !geo )
		return;

	if ( geo->name )
		free( geo->name );

	free( geo );
}


#define OLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLD
#define SIZE			512
/* read a string for a file, testing for comments and empty lines */
sInt readString ( FILE *fp, uByte *buffer, sInt *size ) {
	uByte		*t;
	sInt		lines = 0;
	
	if ( feof(fp) )
		return 0;
	do {
#ifdef USE_GETLINE
		getline( buffer, size, fp );
#else
		fgets( buffer, *size, fp );
#endif
		lines++;
		if ( (t = strchr( buffer, COMMENT )) )
			*t = '\0';
		t = buffer + strlen(buffer);
		while ( isspace( *(--t) && t >= buffer ) )
			*t = '\0';
	} while ( buffer[0] == '\0' && !feof(fp) );
	return lines;
}

sInt u_loadGeometryFile ( uByte *name, u_Geometry *geo ) {
	FILE			*fp;
#ifdef USE_GETLINE
	uByte 			*t, *buffer;
	sInt			size = 0;
#else
	uByte	 		*t, buffer[MAXSIZE];
	sInt			size = MAXSIZE;
#endif
	u_Wireframe		*w;
	u_Volumetric		*v;
	u_NURBS			*n;

	if ( !(fp = fopen( name, "r" )) ) {
		fprintf( stderr, "Could not open file %s", name );
		return ERROR;
	}

	/* parse file */
	if ( readString( fp, buffer, size ) == 0 ) {
		fclose( fp );
		return ERROR;
	}
	if ( !strstr(buffer, "Unreality" ) ) {

	}
	return OK;
}
#endif /**** we'll use bison */

void u_unloadGeometry ( u_Geometry *geo ) {
	u_Wireframe		*w;
	u_Volumetric		*v;
	u_NURBS			*n;
	
	switch ( geo->type ) {
	 case u_gType_None:
	break;

	 case u_gType_Wireframe:
	w = (u_Wireframe *)geo;
	
	break;

	 case u_gType_Volumetric:
	v = (u_Volumetric *)geo;
	
	break;

	 case u_gType_NURBS:
	n = (u_NURBS *)geo;

	break;

	} /* switch */

}
