/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */


/* create a new item in a single linked list poiting to data. */
sint u_addsItem ( u_sList *list, void *data ) {
	u_sItem		*newitem, *index;
	
	if ( list == NULL ) {
		if ( (list = (u_sList *)malloc(sizeof(u_sList))) == NULL  ) {
			fprintf( stderr, "Error allocating list\n" );
			return FATALERROR;
		}
		list->total = 0;
		list->head = NULL;
		list->current = NULL;
	}

	if ( (newitem = (u_sItem *)malloc(sizeof(u_sItem))) == NULL  ) {
		fprintf( stderr, "Error allocating list item\n" );
		return FATALERROR;
	}
	newitem->next = NULL;
	
	if ( list->head == NULL ) {
		list->head = newitem;
		list->total = 1;
		list->current = NULL;
	}
	else {
		index = list->head;
		while ( index->next != NULL )
			index = index->next;
		index->next = newitem;
		list->total++;
	}
	newitem->data = data;

	return OK;
}

void *u_removesItem ( u_sList *list, u_sItem *item ) {
	u_sItem		*index = list->head, *old;
	void		*data;

	if ( list->head == NULL )
		return NULL;

	if ( index == item ) {
		list->head = list->head->next;
		data = index->data;
		free( index );
	}
	else {
		while ( index->next != item && index->next != NULL )
			index = index->next;

		if ( index->next == NULL )
			return NULL;

		old = index->next;
		data = old->data;
		index->next = old->next;
		free( old );
	}

	return data;
}

/* removes first item pointing to data; data may be NULL. OK if removed, ERROR
otherwise. */
sint u_removesItembyData ( u_sList *list, void *data ) {
	u_sItem		*index = list->head, *old;

	if ( list->head == NULL )
		return ERROR;

	if ( index->data == data ) {
		list->head = list->head->next;
		free( index );
	}
	else {
		while ( index->next->data != data && index->next != NULL )
			index = index->next;

		if ( index->next == NULL )
			return ERROR;

		old = index->next;
		index->next = old->next;
		free( old );
	}

	return OK;
}

/* returns head data and zeroes current */
void *u_headsData ( u_sList *list ) {
	if ( list == NULL || list->head == NULL )
		return NULL;

	list->current == list->head;
	return list->current->data;
}

/* returns next data */
void *u_nextsData ( u_sList *list ) {
	if ( list == NULL || list->current == NULL )
		return NULL;
	
	list->current = list->current->next;
	return (list->current == NULL ? NULL : list->current->data);
}