/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */

u_List *objList;

u_Object *u_createObject ( char *name ) {
	u_Object 		*obj;
	Int			i;

	obj = (u_Object *)malloc(sizeof(u_Object));
	if ( !obj ) {
		fprintf( stderr, "Could not allocate object\n" );
		return NULL;
	}

	/* load plugin */
	if ( u_loadPlugin( name, P_OBJECT, (void *)obj ) != OK )
		fprintf( stderr, "Cannot load plugin %s\n", name );
		free( obj );
		return NULL;
	}

	if ( u_addsItem( objList, obj ) != OK ) {
		fprintf( stderr, "Cannot insert object in list\n" );
		u_closePlugin( obj, P_OBJECT );
		free( obj );
		return NULL;
	}
	
	
	return obj;
}

void u_freeObject ( u_Object *obj ) {
	if ( !obj )
		return;

	if ( u_removesItembyData( objList, obj ) != OK )
		fprintf( stderr, "Error deleting object from list, continuing\n" );
	u_freeGeometry( obj->u_geom );
	u_closePlugin( obj )
}
