/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */

u_List *vehList;

u_Vehicle *u_createVehicle ( char *name ) {
	u_Vehicle 	*veh;

	veh = (u_Vehicle *)malloc(sizeof(u_Vehicle));
	if ( !veh ) {
		fprintf( stderr, "Could not allocate vehicle\n" );
		return NULL;
	}

	/* load plugin */
	if ( u_loadPlugin( name, P_VEHICLE, (void *)veh ) != OK )
		fprintf( stderr, "Cannot load plugin %s\n", name );
		free( veh );
		return NULL;
	}


	if ( u_addsItem( vehList, veh ) != OK ) {
		fprintf( stderr, "Cannot insert vehicle in list\n" );
		u_closePlugin( veh, P_VEHICLE );
		free( veh );
		return NULL;
	}
	
	return veh;
}

void u_freeVehicle ( u_Vehicle *veh ) {
	if ( !veh )
		return;

	if ( u_removesItembyData( vehList, veh ) != OK )
		fprintf( stderr, "Error deleting vehicle from list, continuing\n" );
	u_freeGeometry( veh->u_geom );
	u_closePlugin( veh )
}
