/* Unreality
 * Copyright (C) 2000 Bruno Barberi Gnecco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, go to <http://www.gnu.org>.
 */

/* read geometry and store in internal format */
uLong u_addGeometry ( u_Geometry *geom ) { 
	u_Wireframe		*wf;
	u_Volumetric		*v;
	u_Nurbs			*n;

	if ( geom->type[0] == '\0') 
		return FATALERROR;

	if ( geom->type == u_gType_Wireframe ) {
		wf = (u_Wireframe *)geom;
	}
	else if ( geom->type == u_gType_Volumetric ) {
		v = (u_Volumetric *)geom;
	}
	else if ( geom->type == u_gType_NURBS ) {
		n = (u_Nurbs *)geom;
	}
	else {
		fprintf( stderr, "Unknown geometry format %s\n", geom->type );
		return FATALERROR;
	}
	return OK;
}

sInt u_deleteGeometry ( uLong id ) {
	
}
